import { type Setter, type Accessor, type Signal } from 'solid-js';
export declare class Signaled<T, TAccessor extends Accessor<T>, TSetter extends Setter<T> | undefined> {
    private readonly accessor;
    private readonly setter;
    private observable;
    constructor(accessor: TAccessor, setter?: TSetter);
    get value(): T;
    set value(value: TSetter extends Setter<T> ? T : never);
    get untracked(): T;
    subscribe(callback: (value: T) => void): () => void;
    static fromSignal<T, TSignal extends Signal<T>>(signal: TSignal): Signaled<T, TSignal[0], TSignal[1]>;
}
export declare const signaled: <T>(signal: Signal<T>) => Signaled<T, Accessor<T>, Setter<T>>;
