import { untrack, observable } from 'solid-js';
export class Signaled {
    constructor(accessor, setter = undefined) {
        this.accessor = accessor;
        this.setter = setter;
    }
    get value() {
        return this.accessor();
    }
    set value(value) {
        this.setter?.(() => value);
    }
    get untracked() {
        return untrack(this.accessor);
    }
    subscribe(callback) {
        if (!this.observable)
            this.observable = observable(this.accessor);
        return this.observable.subscribe(callback).unsubscribe;
    }
    static fromSignal(signal) {
        return new Signaled(signal[0], signal[1]);
    }
}
export const signaled = (signal) => Signaled.fromSignal(signal);
