import { type Accessor } from 'solid-js';
import { Signaled } from './signaled';
export declare class SignaledIterator<T> extends Signaled<T, Accessor<T>, undefined> {
    readonly unsubscribe: () => void;
    readonly done: Promise<void>;
    constructor(iterator: AsyncIterator<T>, initialValue: T);
    static fromIterator<T>(iterator: AsyncIterator<T>, initialValue: T): SignaledIterator<T>;
    static fromIterable<T>(iterable: AsyncIterable<T>, initialValue: T): SignaledIterator<T>;
}
export declare const createIterator: <T>(iterator: AsyncIterator<T>, initialValue: T) => SignaledIterator<T>;
export declare const createIterable: <T>(iterable: AsyncIterable<T>, initialValue: T) => SignaledIterator<T>;
